﻿using System;
using System.Collections.Generic;
using MySql.Data.MySqlClient;
using Pokedex.Entidade;
using Pokedex.Repository;

namespace PokemonApp
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string connectionString = "Server=localhost;Database=pokedex;User=root;Password=;";
            PokemonRepository pokemonRepo = new PokemonRepository(connectionString);
            TipoRepository tipoRepo = new TipoRepository(connectionString);

            while (true)
            {
                Console.WriteLine("\nEscolha uma opção:");
                Console.WriteLine("1 - Listar todos os Pokémon");
                Console.WriteLine("2 - Adicionar um novo Pokémon");
                Console.WriteLine("3 - Listar Pokémon por tipo");
                Console.WriteLine("4 - Sair");

                string opcao = Console.ReadLine();
                List<Pokemon> pokemons;

                switch (opcao)
                {
                    case "1":
                        pokemons = pokemonRepo.ObterTodosPokemons();

                        foreach(var pokemon in pokemons)
                        {
                            Tipo tipo1 = tipoRepo.ObterTipoPorId(pokemon.Tipo1);
                            Tipo tipo2 = tipoRepo.ObterTipoPorId(pokemon.Tipo2);

                            Console.WriteLine($"Nome: {pokemon.Nome}, Tipo1: {tipo1.Nome}, Tipo2: {tipo2.Nome}");
                        }
                        
                        break;
                    case "2":
                        Console.Write("ID do Pokémon: ");
                        int idPokemon = Convert.ToInt32(Console.ReadLine());
                        Console.Write("Nome do Pokémon: ");
                        string nome = Console.ReadLine();
                        Console.Write("Descrição do Pokémon: ");
                        string descricao = Console.ReadLine();
                        Console.Write("ID do tipo1: ");
                        int idTipo1 = Convert.ToInt32(Console.ReadLine());
                        Console.Write("ID do tipo2: ");
                        int idTipo2 = Convert.ToInt32(Console.ReadLine());

                        Pokemon novoPokemon = new Pokemon { IdPokemon =  idPokemon, Nome = nome, Descricao = descricao, Tipo1 = idTipo1, Tipo2 = idTipo2 };

                        int linhasAfetadas = pokemonRepo.InserirPokemon(novoPokemon);

                        if (linhasAfetadas > 0)
                            Console.WriteLine("Sucesso!");
                        else Console.WriteLine("Falha...");

                        break;
                    case "3":
                        Console.Write("ID do tipo: ");
                        int idTipo = Convert.ToInt32(Console.ReadLine());
                        pokemons = pokemonRepo.ObterTodosPokemonsPorTipo(idTipo);

                        for(int i = 0; i < pokemons.Count; i+=2)
                        {
                            Console.WriteLine($"Nome: {pokemons[i].Nome}");
                        }
                        break;
                    case "4":
                        return;
                    default:
                        Console.WriteLine("Opção inválida! Tente novamente.");
                        break;
                }
            }
        }
    }
}
