﻿using MySql.Data.MySqlClient;
using Pokedex.Entidade;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pokedex.Repository
{
    internal class TipoRepository
    {
        private readonly string _connectionString;

        public TipoRepository(string connectionString)
        {
            _connectionString = connectionString;
        }

        public Tipo ObterTipoPorId(int idTipo)
        {
            Tipo tipo = null;
            using (var connection = new MySqlConnection(_connectionString))
            {
                connection.Open();
                string query = "SELECT * FROM tipo WHERE id_tipo = @idTipo";
                using (var command = new MySqlCommand(query, connection))
                {
                    command.Parameters.AddWithValue("@idTipo", idTipo);
                    using (var reader = command.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            tipo = new Tipo
                            {
                                IdTipo = reader.GetInt32("id_tipo"),
                                Nome = reader.GetString("nome"),
                                Cor = reader.GetString("cor")
                            };
                        }
                    }
                }
            }
            return tipo;
        }
    }
}
